unit Particles;

interface

Uses OpenGL, TGATexture, Octtree, Globals, Classes;



Type  Particle = object
                  X,Y,Z, Lx, Ly, Lz: glFloat;
                  Vx, Vy, Vz: glFloat;
                  Ani: integer;
                  S, Ang, Col: Glfloat;
                  Life, totLife: integer;
                  Line: boolean;
                  Procedure Draw;
                 end;

      ParticleSystem = object
                        X,Y,Z: glFloat;
                        Vx, Vy, Vz: glFloat;
                        Grav, WindX, WindY: glFloat;

                        App, Apv, Size, Damp, Color: glFloat;
                        Mode, Lif, MaxAni: integer; //0 - steam/smoke, 1-Fire
                        P: array of Particle;
                        Tex: gluint;

                        Procedure Init(Xx,Yy,Zz,Vxx,Vyy,Vzz: glFloat; Moode, Num: integer);
                        Procedure Reset;
                        Procedure Tick;
                        Procedure Draw;//(cx,cy,cz: glfloat);
                       end;

      Point = Record
              P: vector; //Position
              M: vector; //Magnitude
              end;

      PointList = object
                  P: array of Point;
                  Procedure Load(fn: string);
                  end;

Var ParticleTex: gluint;
    Up, Right, Pos: Array[0..2] of GlFloat;

Procedure Particles_Init;
Procedure Particles_GetMat;

implementation

Uses Water;

Procedure PointList.Load(fn: string);
Var F: TFileStream;
    B, I: integer;
begin
    F := TFilestream.Create(FN, fmOpenRead);
    F.ReadBuffer(B, Sizeof(integer));

    SetLength(P, B+1);
    For I := 0 to B do
    begin
      F.ReadBuffer(P[I].P, Sizeof(Vector));
      F.ReadBuffer(P[I].M, Sizeof(Vector));
    end;
    F.Free;
end;

Procedure Particles_GetMat;
Var Mat: array[0..15] of glFloat;
begin
   glgetfloatv(gl_modelview_matrix, @mat);
   Right[0] := Mat[0];
   Right[1] := Mat[4];
   Right[2] := Mat[8];

   Up[0] := Mat[1];
   Up[1] := Mat[5];
   Up[2] := Mat[9];

   Pos[0] := Mat[3];
   Pos[1] := Mat[7];
   Pos[2] := Mat[11];

end;

Procedure Particles_Init;
begin


end;

Procedure Particles_DeInit;
begin


end;


{
begin
  X := sx+(random(200)-100)/100*App;
  Y := sy+(random(200)-100)/100*App;
  Z := Sz+(random(200)-100)/100*App;
  Vx := vvx+(random(200)-100)/100*Apv;
  Vy := Vvy+(random(200)-100)/100*Apv;
  Vz := vvz+(random(200)-100)/100*Apv;

  Life := Lif;
  S := 1;

end;

begin
   X := x + Vx;
   Y := y + vy;
   Z := Z + vz;
   Vx := Vx + WindX
end;
 }

Procedure Particle.Draw;
var Tu, Tv, Tu2, Tv2: glFloat;
begin
  if Line then
  begin
   Tu := 0;
   Tv := 0;
   Tu2 := 1;
   TV2 := 1;
  end
  else
  begin
   Tu := (Ani mod 4)/4;
   Tv := 1-((Ani div 4)/4);
   Tu2 := Tu+0.25;
   Tv2 := Tv-0.25;
  end;

  glpushmatrix;
  glColor3f(Col,Col,Col);
   glTranslatef(X,Y,Z);
   glBegin(GL_TRIANGLE_STRIP);

       glTexcoord2f(Tu, Tv) ;glVertex3f(+S*Up[0]-S*Right[0],+S*Up[1]-S*Right[1], +S*Up[2]-S*Right[2]);
       glTexcoord2f(Tu2,Tv) ;glVertex3f(+S*Up[0]+S*Right[0],+S*Up[1]+S*Right[1], +S*Up[2]+S*Right[2]);
       glTexcoord2f(Tu, Tv2);glVertex3f(-S*Up[0]-S*Right[0],-S*Up[1]-S*Right[1], -S*Up[2]-S*Right[2]);
       glTexcoord2f(Tu2,Tv2);glVertex3f(-S*Up[0]+S*Right[0],-S*Up[1]+S*Right[1], -S*Up[2]+S*Right[2]);

   glEnd;
   glPopMatrix;

end;

Procedure ParticleSystem.Init(Xx,Yy,Zz,Vxx,Vyy,Vzz: glFloat; Moode, Num: integer);
begin
 X := Xx;
 Y := yy;
 Z := zz;
 Vx := Vxx;
 Vy := vyy;
 Vz := vzz;
 Mode := moode;
 SetLength(P, Num);
 Reset;
end;

Procedure Particlesystem.Tick;
var I: integer;
begin
   For I := 0 to high(P) do
   begin
    P[I].Lx := P[I].X;
    P[I].Ly := P[I].Y;
    P[I].Lz := P[I].Z;

    P[I].X := P[I].x + P[I].Vx*Damp;
    P[I].Y := P[I].Y + P[I].VY*Damp;
    P[I].Z := P[I].Z + P[I].VZ*Damp;

    P[I].vz := P[I].vz + Grav;

    P[I].Ani := round((1-(P[I].Life/P[I].totLife))*MaxAni);
    if P[I].S < Size then P[I].S := P[I].S + 0.1;
    if P[I].Col < Color then P[I].Col := P[I].Col + 0.1;

     if P[I].Life >= (P[i].totLife div 4) then
     begin
      if P[I].S < Size*3 then P[I].S := P[I].S + 0.05;
      if P[I].Col > 0 then P[I].Col := (P[I].Life/(P[i].totLife div 4))*Color;
     end;

    Dec(P[I].Life);
    if P[I].Life < 0 then
    begin
        Water_Adddrop;

     p[i].X := x+(random(200)-100)/100*App;
     if Mode = 0 then p[i].Y := y+(random(200)-100)/100*App
     else
     p[i].Y := y;
     p[i].Z := z;

     p[i].Vx := vx+(random(200)-100)/100*Apv;
     p[i].Vy := Vy+(random(200)-100)/100*Apv;
     p[i].Vz := vz+(random(200)-100)/100*Apv;
     P[I].Ani := Random(4);
     P[I].Col := 0;
     p[i].totLife := Random(Lif)+10;
     P[I].Life := P[I].TotLife;
     p[i].S := Random(100)/1000;

    end;
   end;
end;


Procedure Particlesystem.Reset;
var I: integer;
begin
   For I := 0 to high(P) do
   begin
     p[i].X := x+(random(200)-100)/100*App;
     p[i].Y := y+(random(200)-100)/100*App;
     p[i].Z := z+(random(200)-100)/100*App;
     p[i].Vx := vx+(random(200)-100)/100*Apv;
     p[i].Vy := Vy+(random(200)-100)/100*Apv;
     p[i].Vz := vz+(random(200)-100)/100*Apv;
     P[I].Ani := 0;

     P[I].Col := 0;
     p[i].totLife := Random(Lif)+10;
     P[I].Life := P[I].TotLife;
     p[i].S := Random(100)/1000;
   end;
end;

Procedure Particlesystem.Draw;//(cx,cY,cz: glfloat);
Var I: integer;
    NumDrawn, Ind: integer;
    D, Fa,xx,yy,zz: single;

begin
  NumDrawn := -1;
  For I := 0 to high(P) do
   P[I].Draw;
  {   p[I].Drawn := false;

 Repeat
  Fa := 0;
  Ind := 0;
  For I := 0 to high(P) do
  if not p[I].Drawn then
  begin
     Xx := cx-P[I].X;
     Yy := cy-P[I].Y;
     Zz := cz-P[I].Z;

     D := sqrt(Xx*XX+Yy*YY+ZZ*ZZ);
     if D > Fa then
     begin
      Fa := D;
      Ind := I;
     end;
  end;
  P[Ind].Draw;
  P[Ind].Drawn := true;
  inc(NumDrawn);

  until NumDrawn >= High(P);
}

end;



end.
